package com.ibm.pureQuery.demo.myclasses;

import java.io.*;
import java.util.*;
import java.sql.*;
import com.ibm.pureQuery.demo.*;
import com.ibm.pdq.annotation.Sql;
import com.ibm.pdq.runtime.Data;
import com.ibm.pdq.runtime.HeterogeneousBatchKind;
import com.ibm.pdq.runtime.factory.DataFactory;

public class HelloWorld_InlineStyle {

	public static void main(String[] args) {
	/**
	 	Data db = DataFactory.getData(getConnection());
		db.setAutoCommit(false);
	*/
	}

	public static void queryProductByNumber(Data db) {
	/**	
	 	Product product = db.queryFirst( "SELECT * FROM GOSALES.PRODUCT " +
				"WHERE PRODUCT_NUMBER=?",Product.class, 1110);
		
			 System.out.println("Base product number: " + 
					 product.getBase_product_number());
	*/
					 
	}

	public static void queryPurchaseOrder(Data db) {
		@Sql
		String strSQL = "SELECT GOSALESCT.CUST.CUST_FRST_NAME, GOSALESCT.CUST.CUST_LAST_NAME,"
				+ "  GOSALESCT.CUST.CUST_PHN_NBR"
				+ "  FROM"
				+ "       GOSALESCT.CUST JOIN GOSALESCT.CUST_ORD ON GOSALESCT.CUST.CUST_CODE = " +
						"GOSALESCT.CUST_ORD.CUST_CODE"
				+ "  WHERE GOSALESCT.CUST_ORD.ORD_DATE = ?";
	/**	
		Iterator<Map<String, Object>> customers = db.queryIterator(strSQL, "2004-11-21");
		while (customers.hasNext()){
		Map<String, Object> customer = customers.next();
		System.out.println("First Name: " + customer.get("cust_frst_name")
		+ "\nLast Name: " + customer.get("cust_last_name")
		+ "\nPHONE: " + customer.get("cust_phn_nbr"));
		}
	*/
	}

	public static void insertManyCustomers(Data db) {

		@Sql
		String strSQL = "INSERT INTO GOSALESCT.CUST (CUST_FRST_NAME, CUST_LAST_NAME, CUST_ADDR1,"
				+ "  CUST_CITY, CUST_PROV_STATE, CUST_POST_ZONE, CUST_CTRY_CODE,"
				+ "  CUST_PHN_NBR, CUST_EMAIL,CUST_INFO)"
				+ "  VALUES (:cust_frst_name, :cust_last_name, :cust_addr1, :cust_city, " +
						":cust_prov_state, :cust_post_zone,"
				+ "    :cust_ctry_code, :cust_phn_nbr, :cust_email, :cust_info)";

		MyCustomer cust1 = new MyCustomer("John", "Doe", "1234 main st",
				"San Jose", "California", "95136", "United States",
				"123-456-7890", "abc@hotmail.com", "New Customer");

		MyCustomer cust2 = new MyCustomer("John1", "Doe1", "1234 main st",
				"San Jose", "California", "95136", "United States",
				"123-456-7890", "abcd@hotmail.com", "New Customer");
		List<MyCustomer> customers = new ArrayList<MyCustomer>();
		customers.add(cust1);
		customers.add(cust2);
		db.updateMany(strSQL, customers);
		db.commit();
	}

	public static void update_heterogenous(Data db) {
		@Sql
		String strSQL1 = "UPDATE GOSALESCT.CUST_ORD"
				+ "  SET ORD_NBR_OF_ITEMS = ORD_NBR_OF_ITEMS + 1"
				+ "  WHERE ORD_NBR = 100000";
		@Sql
		String strSQL2 = "UPDATE GOSALESCT.CUST_ORD_DETL"
				+ "  SET PROD_QTY = PROD_QTY + 1"
				+ "  WHERE ORD_DETL_CODE = 1000000 AND ORD_NBR=100000";

		Map<String, Object> quantity = db.queryFirst("SELECT ORD_NBR_OF_ITEMS"
				+ "  FROM GOSALESCT.CUST_ORD" + "  WHERE ORD_NBR = ?", 100000);

		System.out.println("QUANTITY OF ITMES in GOSALESCT.CUST_ORD BEFORE UPDATE : "
						+ quantity.get("ord_nbr_of_items"));

		quantity = db.queryFirst("SELECT PROD_QTY"
				+ "  FROM GOSALESCT.CUST_ORD_DETL"
				+ "  WHERE ORD_DETL_CODE = ?", 1000000);
		System.out.println("QUANTITY OF ITMES in GOSALESCT.CUST_ORD_DETL  BEFORE UPDATE : "
						+ quantity.get("prod_qty"));

		((Data) db).startBatch(HeterogeneousBatchKind.heterogeneousModify__);
		Object[] empty = new Object[0];

		db.update(strSQL1, empty);
		db.update(strSQL2, empty);
		((Data) db).endBatch();
		db.commit();

		quantity = db.queryFirst("SELECT ORD_NBR_OF_ITEMS"
				+ "  FROM GOSALESCT.CUST_ORD" + "  WHERE ORD_NBR = ?", 100000);
		System.out.println("QUANTITY OF ITMES in GOSALESCT.CUST_ORD AFTER UPDATE : "
						+ quantity.get("ord_nbr_of_items"));

		quantity = db.queryFirst("SELECT PROD_QTY"
				+ "  FROM GOSALESCT.CUST_ORD_DETL"
				+ "  WHERE ORD_DETL_CODE = ?", 1000000);
		System.out.println("QUANTITY OF ITMES in GOSALESCT.CUST_ORD_DETL  AFTER UPDATE : "
						+ quantity.get("prod_qty"));
	}

	/**
	 * Method to call num_of_orders store procedure
	 * 
	 * @param db
	 */
	public static void get_num_of_orders(Data db) {
	/**
		Num_of_ordersSP num_of_orders = new Num_of_ordersSP();
		num_of_orders.setCustomerid(105);
		db.call("call GOSALESCT.NUM_OF_ORDERS(:customerid, :num_of_ord)", num_of_orders);
		System.out.println("Number of orders made by customer "
		+ num_of_orders.getCustomerid() + ": "
		+ num_of_orders.getNum_of_ord());
	*/

	}

	public static void queryCustomerInfo(Data db) {
		@Sql
		String strSQL = "SELECT CUST_FRST_NAME, CUST_LAST_NAME"
				+ "  FROM GOSALESCT.CUST" + "  WHERE CUST_CODE = 100";
	}

	public static void queryCustomerAll(Data db) {
		String outputHtml = db.query("SELECT *" + "  FROM GOSALESCT.CUST",
				new HTMLHandler());
		try {
			FileOutputStream outputStream = new FileOutputStream(
					"CustomerTable.html");
			OutputStreamWriter writer;
			writer = new OutputStreamWriter(outputStream);
			writer.write(outputHtml);
			writer.close();
		} catch (FileNotFoundException e) {
			throw new RuntimeException("Could not write to a file", e);
		} catch (IOException e) {
			throw new RuntimeException("Could not write to file", e);
		}
	}

	public static Connection getConnection() {
		Properties conProperties = new Properties();
		Connection con = null;
		try {
			conProperties.put("user", "username");
			conProperties.put("password", "password");
			conProperties.put("retrieveMessagesFromServerOnGetMessage", "true");
			conProperties.put("emulateParameterMetaDataForZCalls", "1");

			String url = "jdbc:db2://localhost:50000/GSDB";
			Class.forName("com.ibm.db2.jcc.DB2Driver").newInstance();
			con = DriverManager.getConnection(url, conProperties);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return con;
	}
}
