
package com.ibm.pureQuery.demo.myclasses;

import java.sql.SQLException;

import com.ibm.db2.jcc.DB2Connection;
import com.ibm.db2.jcc.DB2SystemMonitor;
import com.ibm.pdq.runtime.Data;
import com.ibm.pdq.runtime.statement.Hook;
import com.ibm.pdq.runtime.statement.SqlStatementType;

/**
 * @author adawra
 * 
 */
public class SystemMonitorHook implements Hook
{
  DB2SystemMonitor systemMonitor;

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.pdq.runtime.statement.Hook#post(java.lang.String, com.ibm.pdq.runtime.Data, java.lang.Object,
   *      com.ibm.pdq.runtime.statement.SqlStatementType, java.lang.Object[])
   */
  public void post (String methodName, Data dataInstance, Object returnValue, SqlStatementType sqlStatementType,
    Object... parameters)
  {
    try {
      systemMonitor.stop ();
      System.out.println("Performance of method: " + methodName  + ":");
      System.out.println ("Application Time: " + systemMonitor.getApplicationTimeMillis () + " milliseconds");
      System.out.println ("Core Driver Time: " + systemMonitor.getCoreDriverTimeMicros () + " microseconds");
      System.out.println ("Network Time: " + systemMonitor.getNetworkIOTimeMicros () + " microseconds");
      System.out.println ("server Time: " + systemMonitor.getServerTimeMicros() + " microseconds");      
    }
    catch (SQLException e) {
      throw new RuntimeException ("Unable to stop system monitor: " + e.getMessage ());
    }
  }

  /*
   * (non-Javadoc)
   * 
   * @see com.ibm.pdq.runtime.statement.Hook#pre(java.lang.String, com.ibm.pdq.runtime.Data,
   *      com.ibm.pdq.runtime.statement.SqlStatementType, java.lang.Object[])
   */
  public void pre (String methodName, Data dataInstance, SqlStatementType sqlStatementType, Object... parameters)
  {
    try {
      systemMonitor = ((DB2Connection) dataInstance.getConnection ()).getDB2SystemMonitor ();
      systemMonitor.enable (true);
      systemMonitor.start (DB2SystemMonitor.ACCUMULATE_TIMES);
    }
    catch (SQLException e) {
      throw new RuntimeException ("Unable to start system monitor " + e.getMessage ());
    }
  }

}
